## Week 1

### 2025.3.23
确定将参赛选题定为proj325。

### 2025.3.25
用原版GPUReplay替代原仓库，简单修改了参考文档。

#### 问题：
1. (已解决)原版GR使用的是发布于**2017年**的Hikey960开发板/Mali-G71 GPU。解决办法包括(1)直接买一块Hikey960，免去编程问题；(2)针对我们自己的开发板，编写相应驱动。
2. (已推翻)我们目前只有raspi5开发板，但raspi5不支持OP-TEE。解决办法是换到OP-TEE已经支持的开发板。

#### 方案：
- (已推翻)最优解是买新一点的板子(支持OP-TEE，最好有Mali-G71 GPU），然后再简单写一点驱动（目前还不清楚原版GR针对Hikey960板子而非GPU的特化代码有多少)。目前看来，ROCK 4B是比较理想的选择：既支持OP-TEE，也是Mali系列的GPU。
- 仍需要进一步分析源代码，以查明要修改哪些驱动。

### 2025.3.26
简单分析GR项目结构。

#### 问题：
1. (已解决)ROCK 4B使用的是Midgard Mali架构GPU，而非Bifrost Mali架构。两者是不同架构，驱动无法通用。因此如果选择ROCK 4B作为开发平台，就必须重新修改驱动。
2. (已推翻&已证伪)GR针对Bifrost驱动的改动，用cloc --diff计算出了至少3000行，远超论文所说的700行。再加上要针对Midgard架构的特点做其他改动，修改驱动会花费很大精力。
3. (已解决)ROCK 4B并不很新（2018年），GPU比Hikey960还老一些。相较Hikey960，除去后者在市面上只有二手货之外，几乎没有选择ROCK 4B的特别理由。

#### 方案：
- (已推翻)再选择ROCK 4B似乎已经不是很现实了，大概率还是得买个Hikey960，快速进入OP-TEE&GR的开发。
- 要仔细考察proj325的四个要求。前两个要求已经隐含在OP-TEE和GR自身中了，后两个要求则需要自己查资料。
- (已废弃)此外，也许还得看看bifrost-driver的开发文档？

### 2025.3.27
编写structure.md，为部分文件添加注释。

#### 方案：
- (已解决。OP-TEE的shell输出不限于UART)和郭老师聊过后，发现raspi5有对Trusted Firmware的支持，可以*尝试*运行OP-TEE。只能使用UART。
- 此外，要修改raspi5 gpu在linux的driver(v3d, vc4)。这之前要先阅读bifrost-driver的修改。
- 阅读linux kernel的DRM drivers文档。仍然有很多东西要学。

### 2025.3.28
阅读driver相关文档，调试raspi5的串口通信，调试raspi的系统，构建OP-TEE。

### 2025.3.29
成功构建OP-TEE并运行xtest。

### 2025.3.30
阅读Linux Device Drivers的第一章，了解了LKM的大致机理及其在内核中的地位等。

## week 2

### 2025.3.31
阅读Linux Device Drivers的第二、三章：了解了module的基本属性，从装载到卸载等；了解char drivers(DRM drivers included)的基本数据结构，如file, fops等，及简单的内存管理、写入与读出。

## todo:
- (已完成)挑重点阅读Linux Device Drivers。
- 分析nano driver。
- 分析v3d driver源码。
- 分析gr driver，根据论文，对比与原版bifrost driver的不同。
- 修改v3d driver。

## notes：

### 有关raspi5移植所涉及的DRM driver
- 原论文Table 3提到了GR在raspi4的实现，框架是ncnn(为手机端优化的神经网络框架，依赖Vulkan)+Vulkan(跨平台的3D图形及计算*标准*)，driver是v3d。
- https://forums.raspberrypi.com/viewtopic.php?t=313260 提到raspi的gpu driver——vc4与v3d的关系：vc4 for 2D, v3d for 3D。
- https://docs.mesa3d.org/drivers/v3d.html 解释了Mesa v3d的性质。Mesa是Vulkan等图形API标准的*实现*，Mesa v3d包含OpenGL和Vulan的driver，使用的kernel DRM driver是v3d(尽管用到了少量的vc4？)。
- 关于所谓的driver stack和driver：https://stackoverflow.com/questions/3200318/device-drivers-vs-driver-stack
- https://www.reddit.com/r/raspberry_pi/comments/18uw25h/how_do_i_install_vulkan_drivers/ 同样提到了raspi所使用的Vulkan(基于Mesa)相关driver。
- 希望每个人都能分清楚标准与实现。

### raspi5与macOS的串口连接
- https://www.jeffgeerling.com/blog/2021/attaching-raspberry-pis-serial-console-uart-debugging 简略描述了配置，要注意接线(此外，手上的杜邦线疑似有问题)。
- https://www.raspberrypi.com/documentation/computers/configuration.html#kernel-command-line-cmdline-txt 提到了console的输出。要想在串口端使用terminal，需把console改到ttyAMA0。
- https://superuser.com/questions/1230735/where-do-i-find-the-default-baud-rate-for-screen-on-mac 提到了macOS的baud rate默认为9600，因此不能按照教程的设置，直接使用115200。可能也与USB-type C转接器有关。

### raspi5的OS
- https://askubuntu.com/questions/1503014/is-there-any-way-i-can-use-ubuntu-22-04-version-in-raspberry-pi-5 表明raspi5不支持Ubuntu 22。花了一个小时鼓捣，最终失败。
- raspi5串口通信对Ubuntu 24的支持似乎也不太好，暂时只能先试试Raspbian。
- Raspbian成功构建OP-TEE并运行xtest。32g的SD卡不够用，需要再插一张16g，然后软链接到out-aarch64-sdk(占空间最大的文件夹)。
- 构建OP-TEE时，需要注意libssl的版本问题，可以直接下载对应版本的包。不能直接把docker里构建的OP-TEE out复制过来，因为docker基于的是qemu。
- 既然直接能在显示器上输出一个secure terminal和一个normal terminal的话，似乎也用不着串口连接了。

### Linux Device Drivers & DRM Drivers
- tbd.